#ifndef MAIN_H_
#define MAIN_H_

#include <wx/app.h>
#include "IOLayer.h"
#include "TrackingLayer.h"
#include "Player.h"

class Program: public wxAppConsole
{
private:
	IOLayer* ioLayer;
	
	wxThread* ioLayerSend;
	wxThread* ioLayerReceive;
	wxThread* trackingLayer;
	
	Repository * repository;
	Player* player;
	
	wxString ip;
	
	FILE* m_pLogFile;
	
	void initApplication();
	void terminateApplication();
	
	#ifdef _BOT_SINGLETHREADED_
	void runSingleThreaded();
	#endif
	
public:
	int OnRun();
	bool OnInit();
};

#endif /*MAIN_H_*/
