#ifndef SHIPSNAPSHOT_H_
#define SHIPSNAPSHOT_H_

#include "Const.h"
#include "FlyingObjectSnapshot.h"
#include "Angle.h"

class ShipSnapshot: public FlyingObjectSnapshot
{
private:
	Angle angle; //der *sichtbare* Winkel des Schiffs; laut c't 64 verschiedene Positionen, wird auf 256 gestreckt
	ShipState state;
public:
	ShipSnapshot(ShipState state,wxPoint pos, Angle angle,int frameID);
	ShipSnapshot():FlyingObjectSnapshot(),angle(0),state(noShip)
	{
	}
	Angle getAngle() const;
	
	ShipState getShipState()
	{
		return state;
	}
	//unsigned int getSize() const;
	
	/*bool equals(const FlyingObjectSnapshot& ref) const;
	
	FlyingObjectType getType() const 
	{
		return FlyingObjectType::ship;
	}*/
};

inline Angle ShipSnapshot::getAngle() const
{
	return this->angle;
}

/*inline unsigned int ShipSnapshot::getSize() const
{
	return 40;
}*/

#endif
